clear
close all
clc

% Load audio signal and choose only first audio channel
[x, fs]     = audioread('aint.wav');
if size(x,1) > size(x,2)
    x           = x(:,1)';
else
    x           = x(1,:);
end
% Define delays
t_0         = ceil(0.1*fs);
ITD         = 30; 
phi_1       = 90;
t_L         = t_0 + 0.5 * ITD * sin(phi_1/180*pi);
t_R         = t_0 - 0.5 * ITD * sin(phi_1/180*pi);

% Define gains
g_L         = 0.3;
g_R         = 0.3;

% Generate impulse responses
h_L         = zeros(max(t_L,t_R),1);
h_R         = zeros(max(t_L,t_R),1);
h_L(1)      = 1;
h_L(t_L)    = g_L;
h_R(1)      = 1;
h_R(t_R)    = g_R;

% Extend audio signal
x           = [x zeros(1,length(h_L))];

%% Generated audio
y_L         = filter(h_L,1,x);
y_R         = filter(h_R,1,x);
y           = [y_L; y_R];

sound(x,fs);
pause(length(x)/fs+1);
sound(y,fs);
pause(length(y)/fs+1);