clear
close all
clc

% Load audio signal and choose only first audio channel
[x, fs]     = audioread('aint.wav');
if size(x,1) > size(x,2)
    x           = x(:,1)';
else
    x           = x(1,:);
end

% Playback of audio signal
sound(x,fs);
pause(length(x)/fs+1);

%% Comb Filter

% Filter parameter
g_c                 = -0.3;
M_c                 = floor(0.1*fs);

% Filter coefficients
b_c                 = zeros(1,M_c+1);
b_c(length(b_c))    = 1;
a_c                 = zeros(1,M_c+1);
a_c(1)              = 1;
a_c(length(a_c))    = -g_c;

% Filtering of audio signal
y_c                 = filter(b_c,a_c,x); 

% Playback of filtered audio signal
sound(y_c,fs);
pause(length(y_c)/fs+1);

%% Allpass filter

% Filter parameter
g_a                 = -0.32;
M_a                 = floor(0.07*fs);

% Filter coefficients
b_a                 = zeros(1,M_a+1);
b_a(1)              = -g_a;
b_a(length(b_a))    = 1;
a_a                 = zeros(1,M_a+1);
a_a(1)              = 1;
a_a(length(a_a))    = -g_a; 

% Filtering of audio signal
y_a                 = filter(b_a,a_a,x); 

% Playback of filtered audio signal
sound(y_a,fs);
