% DASP3rd_Ch7_Ex_4
% Author - Purbaditya Bhattacharya

clear
close all
clc

f_s = 44100;
numsamples = 0.2*f_s;
numdelays = 4;
m1 = 50;
m = m1:ceil(m1*2);

%% Select prime values according to Schrder Method and select the number of delay %%
p = isprime(m);
m = m(p==1);
m = m(1:numdelays);

%% Select the coefficients
g = 0.83;
b = 0.9*ones(numdelays,1);
c = 0.9*ones(numdelays,1);
d = 1;

%% Feedback matrix
Fb_M = (g/sqrt(2)).*diag(ones(1,numdelays));
%Fb_M = (g/sqrt(2)).*[0 1 1 0;-1 0 0 -1;1 0 0 -1;0 1 -1 0]; % for numdelays = 4;

x = zeros(1,numsamples);x(1)=1;
x_i = zeros(length(m),numsamples);
q = zeros(length(m),numsamples);

%% FDN
for n = 1:numsamples
    if n>1
        x_i(:,n) = b.*x(n-1)+ c_fb';
    else
        x_i(:,n) = b.*x(n);
    end
    for i = 1:numdelays
        if n>m(i)
            q(i,n) = x_i(i,n-m(i));
        else
            q(i,n) = 0;
        end
    end
    c_fb = q(:,n)'*Fb_M;
end
%% Output
y = d.*x+sum(c.*q,1);
figure;subplot(2,1,1);stem(x(1:1000));xlabel('n \rightarrow');ylabel('x(n)');subplot(2,1,2);stem(y(1:1000));xlabel('n \rightarrow');ylabel('y(n)');